package de.tu_darmstadt.tk.SmartHomeNetworkSim.core.simpleImplementation;

import java.util.Collection;
import java.util.Iterator;
import java.util.Random;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.control.Controller;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.NetworkManipulationAlgorithm;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.SmartDevice;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.distributionHandler.ConstantValueDistributionHandler;

public class DoSAnomaly implements NetworkManipulationAlgorithm {
	
	@Override
	public void runAlgorithm(Controller controller, long currentTimeStep) {
			if(currentTimeStep == 2000) {
				Collection<SmartDevice> devices = controller.getNetworkController().getVisibleSmartDevices();
				if(devices.isEmpty())return;
				
				Iterator<SmartDevice> it = devices.iterator();
				
				//Find Hub
				while(it.hasNext()){
					if(it.next().getName().equalsIgnoreCase("Hub (Broker)")) {
						SmartDevice hub = it.next();
						hub.getPorts().get(0).setTriggerHandler(new ConstantValueDistributionHandler(1));
						break;
					}
				}
				controller.notifyObservers();
			}
	}
}
